/* 
 * This file is part of the Echo Point Project.  This project is a collection
 * of Components that have extended the Echo Web Application Framework.
 *
 * EchoPoint is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * EchoPoint is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Echo Point; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

function EPPL_findFormElement(elemId) {
	var ea = getElementsById(elemId);
	if (ea != null && ea.length > 0)
		return ea[0].htmlE;
	return null;
}

function EPPL_saveState(E_id, leftSelect, rightSelect) {
	var E_state = "";

	E_state += EPPL_saveListBoxState(leftSelect, "left");
	E_state += EPPL_saveListBoxState(rightSelect, "right");

	if (E_setParameter)
		E_setParameter(E_id, E_state);
}

function EPPL_saveListBoxState(E_select, E_which) {
	var i;
	var E_members = "";
	var E_selection = "";

	// members first    
	for (i = 0; i < E_select.options.length; ++i) {
		if (E_members.length != 0)
			E_members += ",";
		E_members += E_select.options[i].value;
	}
	// then selection
	for (i = 0; i < E_select.options.length; ++i) {
		if (E_select.options[i].selected) {
			if (E_selection.length != 0)
				E_selection += ",";
			E_selection += E_select.options[i].value;
		}
	}
	return E_which + E_members + "@" + E_selection + "|";
}

function EPPL_listSelectionChanged(E_id, E_lbLeftId, E_lbRightId) {
	var E_state = "";
	var leftSelect = EPPL_findFormElement(E_lbLeftId);
	var rightSelect = EPPL_findFormElement(E_lbRightId);

	EPPL_saveState(E_id, leftSelect, rightSelect);
}

function EPPL_swapSelected(E_id, E_fromId, E_toId) {
	var fromSelect = EPPL_findFormElement(E_fromId);
	var toSelect = EPPL_findFormElement(E_toId);
	var i;
	for (i = 0; i < fromSelect.options.length; ++i) {
		if (fromSelect.options[i].selected) {
			var fromOption = fromSelect.options[i];
			var toOption = new Option(fromOption.text, fromOption.value);
			toOption.selected = true;

			toSelect.options[toSelect.options.length] = toOption;
		}
	}
	for (i = fromSelect.options.length - 1; i >= 0; --i) {
		if (fromSelect.options[i].selected) {
			fromSelect.options[i] = null;
		}
	}
	// update our state
	if (E_fromId.indexOf("left") == 0)
		EPPL_saveState(E_id, fromSelect, toSelect);
	else
		EPPL_saveState(E_id, toSelect, fromSelect);
}
