/*
 * This file is part of the SOAFaces Project (hereinafter "SOAFaces").
 * Copyright (C) 2006 Grand Logic, Inc.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */


package org.soafaces.bundle.client.rpc.impl;

import org.soafaces.bundle.client.ui.BaseIOViewer;
import org.soafaces.bundle.client.ui.RuntimeViewer;
import org.soafaces.bundle.client.ui.Weblet;

/**
 *
 * @author Sam Taha
 */
public class MapWebletViewerEnums {
  
  private MapWebletViewerEnums() {}
  
  public static Weblet.Mode getWebletEnum(int ival)
  {
    switch(ival){
      
      case 0: return Weblet.Mode.DEMO;
      case 1: return Weblet.Mode.EDIT;
      case 2: return Weblet.Mode.READONLY;
      case 3: return Weblet.Mode.DESIGN;
   
      
      default: return Weblet.Mode.DEMO;
    }
  }
  
  public static int getWebletInt(Weblet.Mode mode)
  {
    switch(mode){
      
      case DEMO: return 0;
      case EDIT: return 1;
      case READONLY: return 2;
      case DESIGN: return 3;
      
      
      default: return 0;
    }
  }
  
  public static RuntimeViewer.Mode getRuntimeViewerEnum(int ival)
  {
    switch(ival){
      
      case 0: return RuntimeViewer.Mode.DEMO;
      case 1: return RuntimeViewer.Mode.NORMAL;
      
      default: return RuntimeViewer.Mode.DEMO;
    }
  }
  
  public static int getRuntimeViewerInt(RuntimeViewer.Mode mode)
  {
    switch(mode){
      
      case DEMO: return 0;
      case NORMAL: return 1;
      
      default: return 0;
    }
  }

  public static BaseIOViewer.Mode getViewerEnum(int ival)
  {
    switch(ival){

      case 0: return BaseIOViewer.Mode.DEMO;
      case 1: return BaseIOViewer.Mode.NORMAL;

      default: return BaseIOViewer.Mode.DEMO;
    }
  }

  public static int getViewerInt(BaseIOViewer.Mode mode)
  {
    switch(mode){

      case DEMO: return 0;
      case NORMAL: return 1;

      default: return 0;
    }
  }

}
